<?php
/*==========================================================================================================*/
// Estilos heredados del tema padre (obligatorios)
/*==========================================================================================================*/
function my_theme_enqueue_styles() {

 $parent_style = 'parent-style'; // Estos son los estilos del tema padre recogidos por el tema hijo.

 wp_enqueue_style( $parent_style, get_template_directory_uri() . '/style.css' );
 wp_enqueue_style( 'child-style', get_stylesheet_directory_uri() . '/style.css', array( $parent_style ), wp_get_theme()->get('Version') );
}
add_action( 'wp_enqueue_scripts', 'my_theme_enqueue_styles' );

// Meta etiquetas
function add_custom_meta_tags() {
	global $post;
	if ( is_page() || is_single() || is_home() || is_category() ) {
		echo '<meta name="author" content="WeLoveWebs, Christian Cabrero" />' . "\n";
	}
}

add_action( 'wp_head', 'add_custom_meta_tags');

/*==========================================================================================================*/
// js 
/*==========================================================================================================*/
function divi_child_scripts() {
    wp_enqueue_script( 'disable-img-tips-hover', get_stylesheet_directory_uri() . '/js/disable-img-tips-hover.js', array(), '1.0.0', true );
    wp_enqueue_script( 'slick-js', get_stylesheet_directory_uri() . '/js/slick.js', array(), '1.8.0', true );
    //wp_enqueue_script( 'toggle-mobile-menu', get_stylesheet_directory_uri() . '/js/toggle-mobile-menu.js', array(), '1.0.0', true );
}
add_action( 'wp_enqueue_scripts', 'divi_child_scripts' );

/*==========================================================================================================*/
// Estilos públicos
/*==========================================================================================================*/
function public_divi_child_styles() {
    wp_enqueue_style( 'admin-styles', get_stylesheet_directory_uri() . '/css/admin-styles.css', array(), '1.0.0', 'all' );
    //wp_enqueue_style( 'close-icon-mobile-menu', get_stylesheet_directory_uri() . '/css/close-icon-mobile-menu.css', array(), '1.0.0', 'all' );
    //wp_enqueue_style( 'styles-contact-form-7', get_stylesheet_directory_uri() . '/css/styles-contact-form-7', array(), '1.0.0', 'all' );
    //wp_enqueue_style( 'toggle-mobile-menu', get_stylesheet_directory_uri() . '/css/toggle-mobile-menu.css');
    //wp_enqueue_style( 'social-icons', get_stylesheet_directory_uri() . '/css/social-icons.css', array(), '1.0.0', 'all' );
}
add_action( 'wp_enqueue_styles', 'public_divi_child_styles' );

/*==========================================================================================================*/
//Estilos en administración
/*==========================================================================================================*/
function admin_divi_child_styles() {
  wp_enqueue_style('admin-styles', get_stylesheet_directory_uri().'/css/admin-styles.css');
}
add_action('admin_enqueue_scripts', 'admin_divi_child_styles');

/*==========================================================================================================*/
// Shortcode listado de categorías
/*==========================================================================================================*/
function func_categories() {
    $list = wp_list_categories( array(
        'taxonomy'   => 'category',
        'hide_empty' => 0,
        'echo'       => '',
        'title_li'   => '',
        // other args here
    ) );

     return "<ul>$list</ul>";

}

add_shortcode("categorias", "func_categories");

/*==========================================================================================================*/
// Shortcode listado de entradas recientes
/*==========================================================================================================*/
function shapeSpace_recent_posts_shortcode($atts, $content = null) {
	
	global $post;
	
	extract(shortcode_atts(array(
		'cat'     => '',
		'num'     => '5',
		'order'   => 'DESC',
		'orderby' => 'post_date',
	), $atts));
	
	// argumentos del shortcode
	// ej: [recent_posts num="5" cat="7"]
	
	$args = array(
		'cat'            => $cat,
		'posts_per_page' => $num,
		'order'          => $order,
		'orderby'        => $orderby,
	);
	
	$output = '';
	
	$posts = get_posts($args);
	
	foreach($posts as $post) {
		
		setup_postdata($post);
		
		$output .= '<li><a href="'. get_the_permalink() .'">'. get_the_title() .'</a></li>';
		
	}
	
	wp_reset_postdata();
	
	return '<ul>'. $output .'</ul>';
	
}
add_shortcode('recent_posts', 'shapeSpace_recent_posts_shortcode');

/*==========================================================================================================*/
// Shortcode mostrando el año actual
/*==========================================================================================================*/
function current_year_shortcode() {
    $year = date('Y');
    return $year;
}
add_shortcode('current_year', 'current_year_shortcode');

/*==========================================================================================================*/
//CDN librera Font Awesome y Slick JS
/*==========================================================================================================*/
function cdn_function() {
    ?>      
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.1/css/all.min.css" crossorigin="anonymous" referrerpolicy="no-referrer" />
<!-- Add the slick-theme.css if you want default styling -->
<link rel="stylesheet" type="text/css" href="//cdn.jsdelivr.net/gh/kenwheeler/slick@1.8.1/slick/slick.css"/>
<!-- Add the slick-theme.css if you want default styling -->
<link rel="stylesheet" type="text/css" href="//cdn.jsdelivr.net/gh/kenwheeler/slick@1.8.1/slick/slick-theme.css"/>


        <?php 

}
add_action('wp_head', 'cdn_function');

/*==========================================================================================================*/
//Remove jQuery Migrate
/*==========================================================================================================*/
function dequeue_jquery_migrate( $scripts ) {
    if ( ! is_admin() && ! empty( $scripts->registered['jquery'] ) ) {
        $scripts->registered['jquery']->deps = array_diff(
            $scripts->registered['jquery']->deps,
            [ 'jquery-migrate' ]
        );
    }
}
add_action( 'wp_default_scripts', 'dequeue_jquery_migrate' );

/*==========================================================================================================*/
// Shortcode listado de todas las etiquetas
/*==========================================================================================================*/
function func_todas_etiquetas() {
    $tags = get_tags(); // Obtener todas las etiquetas de WordPress
    $tag_list = '';

    if ($tags) {
        $tag_list .= '<ul>';
        foreach ($tags as $tag) {
            $tag_list .= '<li><a href="' . get_tag_link($tag) . '">' . $tag->name . '</a></li>';
        }
        $tag_list .= '</ul>';
    }

    return $tag_list;
}
add_shortcode("list_all_tags", "func_todas_etiquetas");

/*==========================================================================================================*/
// Shortcode listado de etiquetas post
/*==========================================================================================================*/
function func_etiquetas_post() {
    $tag_list = get_the_tag_list( '<ul><li>', '</li><li>', '</li></ul>' );
if ( $tag_list && ! is_wp_error( $tag_list ) ) {
	return $tag_list;
}
}
add_shortcode("list_this_tags", "func_etiquetas_post");

/*==========================================================================================================*/
// Deshabilita el CPT proyects
/*==========================================================================================================*/
add_action( 'init', 'wlw_remove_divi_project_post_type' );

if ( ! function_exists( 'wlw_remove_divi_project_post_type' ) ) {
	
	function wlw_remove_divi_project_post_type(){
		unregister_post_type( 'project' );
		unregister_taxonomy( 'project_category' );
		unregister_taxonomy( 'project_tag' );
	}
}

/*==========================================================================================================*/
/* Activar capacidad de hacer zoom en dispositivos moviles */
/*==========================================================================================================*/
function disable_et_add_viewport_meta() {     //desactiva viewport del tema divi
    remove_action( 'wp_head', 'et_add_viewport_meta' );
}
add_action( 'after_setup_theme', 'disable_et_add_viewport_meta');
function add_pinch_zoom_viewport_meta(){      //inserta viewport meta activando el zoom
    echo '<meta name="viewport" content="width=device-width, initial-scale=1" />';
}
add_action( 'wp_head', 'add_pinch_zoom_viewport_meta');
add_action('wp_ajax_cargar_mas_posts', 'cargar_mas_posts');
add_action('wp_ajax_nopriv_cargar_mas_posts', 'cargar_mas_posts');


/*==========================================================================================================*/
// Shortcode grid galeria
/*==========================================================================================================*/
function grid_galeria_shortcode()  {

$term = get_queried_object();
$images = get_field('galeria', $term);//add your correct field name

	ob_start();
	
	if( $images ): 
	 ?>
	
		<div class="grid-galeria galeria-lightbox">
			<ul>
				<?php foreach( $images as $image ): ?>
				<li data-thumb="<?php echo $image['url']; ?>">
					<a href="<?php echo $image['url']; ?>">
						<img src="<?php echo $image['url']; ?>"/>
						<p class="titulo"><?php echo $image['title']; ?></p>
						<p class="leyenda"><?php echo $image['caption']; ?></p>
					</a>
				</li>
				<?php endforeach; ?>
		 	</ul>
		</div>
		
	<?php endif; 
		
	return ob_get_clean();

}
add_shortcode( 'grid_galeria', 'grid_galeria_shortcode' );



/*==========================================================================================================*/
// Shortcode slider como trabajamos
/*==========================================================================================================*/
function slider_trabajamos_shortcode()  {

$term = get_queried_object();
$images = get_field('slider_trabajamos', $term);//add your correct field name

	ob_start();
	
	if( $images ): 
	 ?>
	
		<div class="slider-trabajamos galeria-lightbox">
			<ul>
				<?php foreach( $images as $image ): ?>
				<li data-thumb="<?php echo $image['url']; ?>">
					<a href="<?php echo $image['url']; ?>">
						<img src="<?php echo $image['url']; ?>"/>
					</a>
				</li>
				<?php endforeach; ?>
		 	</ul>
		</div>
		
	<?php endif; 
		
	return ob_get_clean();

}
add_shortcode( 'slider_trabajamos', 'slider_trabajamos_shortcode' );



/*==========================================================================================================*/
// Shortcode grid galeria como trabajamos
/*==========================================================================================================*/
function grid_galeria_trabajamos_shortcode()  {

$term = get_queried_object();
$images = get_field('galeria_trabajamos', $term);//add your correct field name

	ob_start();
	
	if( $images ): 
	 ?>
	
		<div class="galeria-trabajamos galeria-lightbox">
			<ul>
				<?php foreach( $images as $image ): ?>
				<li data-thumb="<?php echo $image['url']; ?>">
					<a href="<?php echo $image['url']; ?>">
						<img src="<?php echo $image['url']; ?>"/>
						<p class="titulo"><?php __($image['title'],'Divi WeloveWebs'); ?></p>
						<p class="leyenda"><?php __($image['caption'],'Divi WeloveWebs'); ?></p>
					</a>
				</li>
				<?php endforeach; ?>
		 	</ul>
		</div>
		
	<?php endif; 
		
	return ob_get_clean();

}
add_shortcode( 'grid_galeria_trabajamos', 'grid_galeria_trabajamos_shortcode' );



/*==========================================================================================================*/
/* Filtro de proyectos */
/*==========================================================================================================*/

function shortcode_lista_categorias_proyectos() { 
//$string .= '<h2>Categorías</h2>';
$string = '';
$string .= '<ul id="filtro-proyectos">';

  $taxonomy     = 'category';
	$post_type     = 'proyecto';
  $orderby      = 'name';  
  $show_count   = 1;      // 1 for yes, 0 for no
  $pad_counts   = 0;      // 1 for yes, 0 for no
  $hierarchical = 1;      // 1 for yes, 0 for no  
  $title        = '';  
  $empty        = 1;

  $args = array(
         'taxonomy'     => $taxonomy,
	  	'post_type' => $post_type,
         'orderby'      => $orderby,
         'show_count'   => true,
         'pad_counts'   => $pad_counts,
         'hierarchical' => $hierarchical,
         'title_li'     => $title,
         'hide_empty'   => $empty
  );
	
$args = array('exclude' => array(1,3,4,5,27)); //Excluye del loop las no categorizadas
 $all_categories = get_categories( $args );
 foreach ($all_categories as $cat) {
	 
	$cat_id = $cat->term_id;

    if($cat->category_parent == 0) {
        $string .= '<li class="parent" data-category="'.$cat->slug.'"><a class="'.$cat->slug.'" href="'. get_term_link($cat->slug, 'category') .'">'. $cat->name .'</a>';
    
		$args2 = array(
                'taxonomy'     => $taxonomy,
                'child_of'     => 0,
                'parent'       => $cat_id,
                'orderby'      => $orderby,
                'show_count'   => true,
                'pad_counts'   => $pad_counts,
                'hierarchical' => $hierarchical,
                'title_li'     => $title,
                'hide_empty'   => $empty
        );
        $sub_cats = get_categories( $args2 );

			if($sub_cats){
				$string .= '<ul>';
				foreach($sub_cats as $sub_category) {
					$string .= '<li data-category="'.$sub_category->slug.'">';
					$string .= '<a href="'. get_term_link($sub_category->slug, 'category') .'" style="margin-left:1em;">'.$sub_category->name;
					$string .= '</a></li>';
				}
				
				$string .= '</ul>';
			} else {
				//si no hay mas sub categorias, cierra li
				//$string .= '</li>';
			}

		}
	 
 }

$string .= '<li class="todos"><a href="#">'.__('Ver todos','Divi WeloveWebs').'</a></li></ul>';

 return $string; 

 
}
// Register shortcode
add_shortcode('custom_category_posts_filter', 'shortcode_lista_categorias_proyectos'); 




/*==========================================================================================================*/
// Shortcode grid proyectos
/*==========================================================================================================*/
function grid_proyectos_shortcode($atts, $content = null) {
	
	global $post;
	
	//$lista_cursos = array();
	
	extract(shortcode_atts(array(
		'cat' => '',
		'num' => '-1',
		'product_cat' => '',
		'order' => 'DESC',
		'post_status' => 'publish',
		'orderby' => 'post_date',
		'post_type' => 'proyecto',
		'category' => '',
	), $atts));
	
	// argumentos del shortcode
	// ej: [recent_posts num="5" cat="7"]
	
	$args = array(
		'cat' => $cat,
		'category' => $category,
		//'taxonomy' => 'proyectos',
		'posts_per_page' => $num,
		'order' => $order,
		'orderby' => $orderby,
		'post_type' => $post_type,
		'suppress_filters' => false, //Muestra posts sólo del lenguaje actual
	);
	
	if ( ! empty( $category ) ) {
        $args['category_name'] = $category;
    }
	
	$output = '';
	
	$posts = get_posts($args);
	
	foreach($posts as $post) {
		
		//setup_postdata($post);
		
		$url_categorias = '';
		
		$post_thumbnail_id = get_post_thumbnail_id( $post );

		if ( ! $post_thumbnail_id ) {
			$thumbnail_url = '/wp-content/uploads/2024/04/logo-ioskateparks-negro.webp';
		} else {
			$thumbnail_url = wp_get_attachment_image_url( $post_thumbnail_id, 'large' );
		}

		$nombres_categorias = array();
		$currentID = $post->ID;
		$category_detail=get_the_category($currentID); // $post->ID
		foreach($category_detail as $currentcat){
			$catId = $currentcat->ID;
			$url_categorias = $currentcat->slug." ";
			array_push($nombres_categorias, $currentcat->name); //push it
		}
		$nombre_sub_categoria = implode(", ", $nombres_categorias);
		
		$output .= '<li class="'.$url_categorias.'" data-categoria="'.$nombre_sub_categoria.'" style="background-image:url('.$thumbnail_url.');"><a class="titulo" href="'. get_the_permalink() .'">'.get_the_title().'</a></li>';
		
	}
	
    //Filtro de categorías superior
    $categories = get_categories( array(
    'orderby' => 'name',
    'order'   => 'ASC'
    ) );
 
	wp_reset_postdata();
	
	return '<ul id="grid-proyectos">'.$output.'</ul>';
	
}
add_shortcode('grid_proyectos', 'grid_proyectos_shortcode');


/*==========================================================================================================*/
// Shortcode grid proyectos destacados
/*==========================================================================================================*/
function slider_proyectos_destacados_shortcode($atts, $content = null) {
	
	global $post;
	
	$post_ids = array();
	
	if (isset($atts['ids'])) {
		$post_ids = explode(",", $atts['ids']);
	}
	
	
	
	extract(shortcode_atts(array(
		'cat' => '',
		'num' => '20',
		'product_cat' => '',
		'orderby' => 'post_date',
		'order' => 'DESC',
		'post_status' => 'publish',		
		'post_type' => 'proyecto',
		'category' => '',
		'ids' => '',
	), $atts));
	
	// argumentos del shortcode
	// ej: [recent_posts num="5" cat="7"]
	
	$args = array(
		'cat' => $cat,
		'category' => $category,
		'taxonomy' => 'proyectos',
		'posts_per_page' => $num,
		'order' => $order,
		'orderby' => $orderby,
		'post_type' => $post_type,
		'post__in' => $post_ids,
		'post__not_in' => array( $post->ID ),
		'suppress_filters' => false, //Muestra posts sólo del lenguaje actual
	);
	// use attr ids="4,7,9,4..." for show only few posts
	
	if ( ! empty( $category ) ) {
        $args['category_name'] = $category;
    }
	
	$output = '';
	
	$posts = get_posts($args);
	
	foreach($posts as $post) {
				
		$url_categorias = '';
		
		$post_thumbnail_id = get_post_thumbnail_id( $post );

		if ( ! $post_thumbnail_id ) {
			return false;
		}

		$thumbnail_url = wp_get_attachment_image_url( $post_thumbnail_id, 'full' );
				
		$output .= '<li style="background-image:url('.$thumbnail_url.');"><div><h3 class="titulo">'.get_the_title().'</h3><a href="'. get_the_permalink() .'">'.__('Ver proyecto','Divi WeloveWebs').'</a></div></li>';
		
	}
 
	wp_reset_postdata();
	
	return '<ul id="proyectos-destacados">'.$output.'</ul>';
	
}
add_shortcode('slider_proyectos_destacados', 'slider_proyectos_destacados_shortcode');


/*==========================================================================================================*/
// Shortcode grid proyectos relacionados
/*==========================================================================================================*/
function slider_proyectos_relacionados_shortcode($atts, $content = null) {
	
	global $post;
	
	//$lista_cursos = array();
	
	extract(shortcode_atts(array(
		'cat' => '',
		'num' => '6',
		'product_cat' => '',
		//'orderby' => 'post_date',
		'orderby' => 'rand',
		'order' => 'DESC',
		'post_status' => 'publish',		
		'post_type' => 'proyecto',
		'category' => '',
	), $atts));
	
	// argumentos del shortcode
	// ej: [recent_posts num="5" cat="7"]
	
	$args = array(
		'cat' => $cat,
		'category' => $category,
		'taxonomy' => 'proyectos',
		'posts_per_page' => $num,
		'order' => $order,
		'orderby' => $orderby,
		'post_type' => $post_type,
		'post__not_in' => array( $post->ID ),
		'suppress_filters' => false, //Muestra posts sólo del lenguaje actual
	);
	
	if ( ! empty( $category ) ) {
        $args['category_name'] = $category;
    }
	
	$output = '';
	
	$posts = get_posts($args);
	
	foreach($posts as $post) {
				
		$url_categorias = '';
		
		$post_thumbnail_id = get_post_thumbnail_id( $post );

		if ( ! $post_thumbnail_id ) {
			return false;
		}

		$thumbnail_url = wp_get_attachment_image_url( $post_thumbnail_id, 'full' );
				
		$output .= '<li style="background-image:url('.$thumbnail_url.');"><h3 class="titulo">'.get_the_title().'</h3><a href="'. get_the_permalink() .'">'.__('Ver proyecto','Divi WeloveWebs').'</a></li>';
		
	}
 
	wp_reset_postdata();
	
	return '<ul id="proyectos-destacados">'.$output.'</ul>';
	
}
add_shortcode('slider_proyectos_relacionados', 'slider_proyectos_relacionados_shortcode');



/*==========================================================================================================*/
// Redirect the attachment pages to the file itself for SEO reasons.
/*==========================================================================================================*/
function welovewebs_redirect_attachment_page() {
    if ( is_attachment() ) {
        global $post;
        if ( is_a( $post, 'WP_Post' ) ) {
            $redirect = esc_url( wp_get_attachment_url( $post->ID ) );
            if ( $redirect && wp_safe_redirect( $redirect, 301 ) ) {
                exit;
            }
        }
    }
}
add_action( 'template_redirect', 'welovewebs_redirect_attachment_page' );